uses Windows, crit_cns, Win32Ctrl_Macro;

{$R CRITSECS.RES}

var
  g_hwndDlg             : HWND = 0;
  g_CriticalSection     : CRITICAL_SECTION;
  DataBox               : HWND;
  g_hThreadCntr         : THandle = 0;
  g_hThreadDspy         : THandle = 0;
//६  
  g_szNumber            : string = '0';

procedure FillCombo(hWndCtl:HWND; Flag:boolean);
begin
  ComboBox_AddString(hwndCtl, 'Idle');
  if Flag then ComboBox_AddString(hwndCtl, 'Lowest');
  if Flag then ComboBox_AddString(hwndCtl, 'Below normal');
  ComboBox_AddString(hwndCtl, 'Normal');
  if Flag then ComboBox_AddString(hwndCtl, 'Above normal');
  ComboBox_AddString(hwndCtl, 'High');
  ComboBox_AddString(hwndCtl, 'Realtime');
  //normal
  if Flag then ComboBox_SetCurSelect(hwndCtl, 3)
  else ComboBox_SetCurSelect(hwndCtl, 1)
end;

procedure AddToListBox(szBuffer:PChar);
var
  x:integer;
begin
  X:=ListBox_AddString(DataBox, szBuffer);
  ListBox_SetSelected(DataBox, x);
  if ListBox_GetCount(DataBox)>100 then ListBox_DeleteString(DataBox, 0);
end;

function CounterThread(lpThreadParametr:LPVOID):DWORD;stdcall;
var
  fSyncChecked:boolean;
  i,j:integer;
  nNumber:longint;
begin
  while true do
  begin
    fSyncChecked:=Button_GetCheck(GetDlgItem(g_hwndDlg, IDC_SINCHRONIZE));
    if fSyncChecked then //᫨ 짮⥫  ᨭ஭஢ -  ஢
      EnterCriticalSection(g_CriticalSection);
    Val(g_szNumber, nNumber,j);
    for i:=1 to 10 do Sleep(0);
    nNumber:=nNumber+1;
    Str(nNumber, g_szNumber);
    if fSyncChecked then //᫨ 짮⥫  ᨭ஭஢ -  ஢
      LeaveCriticalSection(g_CriticalSection);
    if Button_GetCheck(GetDlgItem(g_hwndDlg, IDC_SHOWCNTRTHRD)) then
       AddToListBox('Cntr: Increment');
  end;
end;

function DisplayThread(lpThreadParametr:LPVOID):DWORD;stdcall;
var
  fSyncChecked:boolean;
  S:string;
begin
  while true do
  begin
    fSyncChecked:=Button_GetCheck(GetDlgItem(g_hwndDlg, IDC_SINCHRONIZE));
    if fSyncChecked then //᫨ 짮⥫  ᨭ஭஢ -  ஢
      EnterCriticalSection(g_CriticalSection);
    S:='Dispy: '+g_szNumber+#0;
    if fSyncChecked then //᫨ 짮⥫  ᨭ஭஢ -  ஢
      LeaveCriticalSection(g_CriticalSection);
    AddToListBox(@S[1]);
  end;
end;

function DlgCommand(Wnd:HWND; ID:int; WndCtl:HWND; CodeNotify:UINT):boolean;
var
  dw:DWORD;
begin
  Result:=true;
  case id of
    IDCANCEL:EndDialog(Wnd, id);
    IDC_DSPYTHRDPRIORITY,
    IDC_CNTRTHRDPIORITY,
    IDC_PRIORITYCLASS:
              if CodeNotify<>CBN_SELCHANGE then
              begin
                case ComboBox_GetCurSelect(wndCtl) of
                  0:dw:=THREAD_PRIORITY_IDLE;
                  1:dw:=THREAD_PRIORITY_LOWEST;
                  2:dw:=THREAD_PRIORITY_BELOW_NORMAL;
                  3:dw:=THREAD_PRIORITY_NORMAL;
                  4:dw:=THREAD_PRIORITY_ABOVE_NORMAL;
                  5:dw:=THREAD_PRIORITY_HIGHEST;
                  6:dw:=THREAD_PRIORITY_TIME_CRITICAL;
                else
                  dw:=THREAD_PRIORITY_IDLE;
                end;
                case id of
                  IDC_DSPYTHRDPRIORITY:SetThreadPriority(g_hThreadDspy, dw);
                  IDC_CNTRTHRDPIORITY:SetThreadPriority(g_hThreadCntr, dw);
                  IDC_PRIORITYCLASS:SetThreadPriority(GetCurrentProcess, dw)
                end;
              end;
    IDC_PAUSE:begin
                if Button_GetCheck(WndCtl) then
                begin
                  SuspendThread(g_hThreadCntr);
                  SuspendThread(g_hThreadDspy);
                end
                else
                begin
                  ResumeThread(g_hThreadCntr);
                  ResumeThread(g_hThreadDspy);
                end;
              end;
  else
    Result:=false;
  end;
end;

function DlgOnInitDialog(Wnd:HWND; hWNDFocus:HWND; lParams:LPARAM):boolean;
var
  dwThreadID:DWORD;
begin
  SetClassLong(wnd, GCL_HICON, Long(LoadIcon(GetWindowLong(Wnd, GWL_HINSTANCE), 'CRITSECS')));
  g_hwndDlg:=Wnd;
  InitializeCriticalSection(g_CriticalSection);
  g_hThreadCntr:=CreateThread(nil,0,@CounterThread,nil,0, dwThreadID);
  g_hThreadDspy:=CreateThread(nil,0,@DisplayThread,nil,0, dwThreadID);
  //塞 
  FillCombo(GetDlgItem(Wnd, IDC_PRIORITYCLASS), false);
  FillCombo(GetDlgItem(Wnd, IDC_DSPYTHRDPRIORITY), true);
  FillCombo(GetDlgItem(Wnd, IDC_CNTRTHRDPIORITY), true);
  DataBox:=GetDLgItem(g_hwndDlg,  IDC_DATABOX);
  Result:=true;
end;

function DlgOnDestroy(Wnd:HWND):boolean;
begin
  TerminateThread(g_hThreadCntr,0);
  TerminateThread(g_hThreadDspy,0);
  DeleteCriticalSection(g_CriticalSection);
  Result:=true;
end;

function DlgProc(hDlg:HWND; uMsg:UINT; wParams:WPARAM; lParams:LPARAM):BOOL;stdcall;
begin
  case uMsg of
    WM_INITDIALOG:Result:=DlgOnInitDialog(hDlg, HWND(wParams), lParams);
    WM_COMMAND:Result:=DlgCommand(hDlg, LoWord(wParams), HWND(lParams), HiWord(wParams));
    WM_DESTROY:Result:=DlgOnDestroy(hDlg);
  else
    Result:=false;
  end;
end;

begin
  DialogBox(HInstance, PChar(IDD_CRITSECS), 0, @DlgProc);
end.
